<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Oppgave 1. Glasset med ananasjuice (25%)</title>
	<style>
		/*
			*******
				Denne CSS-koden skal ikke endres
			*******
		*/
		#glass-div{
			width: 150px;
			height: 350px;
			border: 1px solid black;
			border-top: none;
			margin-top: 50px;
			position: relative;
		}		
		#juice-div{
			height: 50px;
			width: 100%;
			background-color: rgb(230, 230, 50);
			opacity: 0.5;
			position: absolute;
			bottom: 0;
			transition: height 2s;
		}		
		#status-p{
			color: red;
		}		
	</style>
</head>
<body>
		
	<h3>Ananasjuicedrikking</h3>
	
	<label>Juice-mengde</label>
	<input id="juice-amount-txt" type="text">
		
	<input id="pour-more-juice-btn" type="button" value="Hell i mer juice">
	<input id="drink-juice-btn" type="button" value="Drikk juice">
	
	<p id="status-p">Status nå: OK</p>
	
	<div id="glass-div">
		<span id="juice-level-span">50</span>
		<div id="juice-div"></div>
	</div>
		
	<script>
		/* Besvarelse her */
		const MAX_JUICE_VOL = 350;
		const MIN_JUICE_VOL = 0;

		const STATUS_FULL = "FULL";
		const STATUS_EMPTY = "EMPTY";
		const STATUS_OK = "OK";
		const STATUS_MISSING_INPUT = "MISSING_INPUT";

		//TODO evaluate need for global variable
		let juiceAmt = 50;
		let missingInput = true;

		const pourJuiceBtn = document.getElementById("pour-more-juice-btn");
		const drinkJuiceBtn = document.getElementById("drink-juice-btn");
		const juiceSpan = document.getElementById("juice-level-span");


		//Registering listeners
		pourJuiceBtn.onclick = fillJuice;
		drinkJuiceBtn.onclick = drinkJuice;

		function setJuiceContent(juiceAmt) {
			const juiceDiv = document.getElementById("juice-div");

			if (juiceAmt <= MAX_JUICE_VOL && juiceAmt >= MIN_JUICE_VOL) {
				juiceSpan.innerHTML = juiceAmt;
				juiceDiv.style.height = juiceAmt + "px";
			}
			else {
				if (juiceAmt > MAX_JUICE_VOL) {
					setJuiceContent(MAX_JUICE_VOL);
				}
				else {
					setJuiceContent(MIN_JUICE_VOL);
				}
			}
		}

		function setStatus(status) {
			const statusP = document.getElementById("status-p");
			let statusMsg = ""
			switch (status) {
				case STATUS_FULL:
					statusMsg = "Glasset er fullt";
					break;

				case STATUS_EMPTY:
					statusMsg = "Glasset er tomt";
					break;

				case STATUS_OK:
					statusMsg = "Status nå: OK";
					break;

				case STATUS_MISSING_INPUT:
					statusMsg = "Du må fylle inn et tall";
					break;
			}
			statusP.innerHTML = statusMsg;
		}

		function evaluateStatus() {
			getCurrentJuiceAmt();
			if (juiceAmt >= MAX_JUICE_VOL) {
				setStatus(STATUS_FULL);
			}
			else if (juiceAmt <= MIN_JUICE_VOL) {
				setStatus(STATUS_EMPTY);
			}
			else {
				setStatus(STATUS_OK);
			}
		}

		function getFilledJuiceAmt() {
			const juiceInput = document.getElementById("juice-amount-txt");
			let juiceAmtFilled = 0;
			if (juiceInput.value.length) {
				missingInput = false;
				juiceAmtFilled = parseInt(juiceInput.value);
			}
			else {
				//handle input box empty
				missingInput = true;
			}
			return juiceAmtFilled;
		}

		function getCurrentJuiceAmt() {
			juiceAmt = parseInt(juiceSpan.innerHTML);
			return juiceAmt;
		}

		function handleJuiceAdjustments(newJuiceAmt) {
			if (!missingInput) {
				setJuiceContent(newJuiceAmt);
				evaluateStatus();
			}
			else {
				setStatus(STATUS_MISSING_INPUT);
			}
		}

		function drinkJuice() {
			handleJuiceAdjustments(getCurrentJuiceAmt() - getFilledJuiceAmt());
		}

		function fillJuice() {
			handleJuiceAdjustments(getCurrentJuiceAmt() + getFilledJuiceAmt());
		}
	</script>
	
</body>
</html>